" Vim syntax file
" Language:	Firestorm config file
" Maintainer:	Gianni Tedesco <gianni@ecsc.co.uk>
" Last Change:	2001 Jun 6


" Quit when a syntax file was already loaded
if exists("b:current_syntax")
  finish
endif

" firestorm.conf syntax seems is case sensitive
syn case ignore

syn keyword	firestormTodo		contained TODO
syn match	firestormComment	"#.*$" contains=firestormTodo

" All our keywords
syn keyword	firestormConf	load_plugins plugin_require global
syn keyword	firestormConf	capdev_add
syn keyword	firestormConf	load_ruleset
syn keyword	firestormConf	firestorm_root chroot effective_user effective_group

syn match	firestormAction	"firestorm\.conf"

syn match	firestormNumber	"\<\d\+\>"
syn match	firestormIP	"\<\d\{1,3}\.\d\{1,3}\.\d\{1,3}\.\d\{1,3}\>"

" All config is in one line, so this has to be sufficient
" Make it fast like hell :)
syn sync minlines=3

" The default highlighting.
hi def link firestormTodo		Todo
hi def link firestormComment		Comment
hi def link firestormConf		Keyword
hi def link firestormAction		String
hi def link firestormNumber		Number
hi def link firestormIP			Number

let b:current_syntax = "firestorm"

" vim: ts=8
