#ifndef __S_GLOBALS_HEADER_INCLUDED__
#define __S_GLOBALS_HEADER_INCLUDED__

#include <g_globals.h>
#include <packet.h>

/* List of strings */
typedef struct config_arg {
	list_head_t     l;
	char		*arg;
}config_arg_t, *p_config_arg;

/* A key/value list element */
typedef struct kv {
	list_head_t     l;
	int             flags;
	char            *key;
	char            *val;
}kv_t, *p_kv;

/* Same as above, except 3 strings  */
typedef struct c_capdev{
	list_head_t     l;
	char            *type;
	char            *source;
	char            *filter;
}c_capdev_t, *p_c_capdev;

typedef struct sensor_globals_t{
	/* Memory management */
	proc_malloc		malloc;
	proc_free		free;
	proc_fs_strdup 		fs_strdup;
	
	/* Global locking and management type stuff */
	mlock_t			tlock; /* Lock glibc localtime() buffer */
	mlock_t			glock; /* Global sensor I/O lock */
	atomic_counter_t	keepalive; /* Alive captures  */
	char			*config_fn; /* Config file filename */

	/* Count the number of each type of resourcr allocated */
	uint			num_plugins; /* Number of loaded plugins */
	uint			num_rules; /* Number of rules in */
	uint			num_rulefiles; /* Rule files loaded */
	uint			num_matchers; /* Matchers */
	uint			num_targets; /* Loaded targets */
	uint			num_captypes; /* Loaded capture types */
	
	/* KILLED AFTER config_go() !! */
	/* ------------------------------- */
	p_config_arg		plugin_dirs; /* List of plugin dirs  */
	p_c_capdev		capdevs;
	p_kv			rulesets;
	char			*root_dir;
	/* ------------------------------- */
	
	/* Security information */
	uid_t			uid;
	gid_t			gid;
	int			chroot;

	/* List of global plugin variables */
	p_kv			plugin_vars;
}sensor_globals_t;

extern struct sensor_globals_t globals;

#endif //__S_GLOBALS_HEADER_INCLUDED__
