#include <arp.h>
PLUGIN_DECLARE_STD_IMPORTS;

proc_demux_add_handler add_demux;

uint _PLUGIN_INIT (p_plugin_in in, p_plugin_out out)
{
	PLUGIN_CHECK_PARAMS(in);
	PLUGIN_IMPORT_STD;
	
	add_demux=in->add_demux;

	out->name="proto/arp";
	out->desc="ARP/RARP is an ethernet address resolution protocol";
	out->ver_major=1;
	out->ver_minor=0;
	
	if ( !(add_demux(LAYER_NET, demux_callback)) ) {
		return PLUGIN_ERR_FAIL;
	}else{	
		return PLUGIN_ERR_OK;
	}
}

/* This is where we would cleanup our shit */
uint _PLUGIN_UNLOAD (void)
{
	return PLUGIN_ERR_OK;
}

/* This is our actual demultiplex handler */

#define NPROTO_ARP	0x0806
#define NPROTO_RARP 	0x8035

demux_pret_t demux_callback(p_packet p)
{
	if ( !p->layer[LAYER_LINK].h.raw ) return DEMUX_NULL;
	if ( !p->layer[LAYER_NET].h.raw ) return DEMUX_NULL;

	if ( p->layer[LAYER_NET].id != NPROTO_ARP &&
		p->layer[LAYER_NET].id != NPROTO_RARP ) return DEMUX_NULL;

	if ( p->layer[LAYER_NET].id == NPROTO_ARP ){
		p->layer[LAYER_NET].name = "ARP";
		p->layer[LAYER_TRANS].name = p->layer[LAYER_NET].name;
		p->layer[LAYER_APP].name = p->layer[LAYER_NET].name;
	}else{
		p->layer[LAYER_NET].name = "RARP";
		p->layer[LAYER_TRANS].name = p->layer[LAYER_NET].name;
		p->layer[LAYER_APP].name = p->layer[LAYER_NET].name;
	}

	p->layer[LAYER_TRANS].id = 0;
	p->layer[LAYER_TRANS].h.raw = p->layer[LAYER_NET].h.raw;
	p->layer[LAYER_APP].h.raw= p->layer[LAYER_NET].h.raw;
	p->layer[LAYER_APP].id = 0;
	
	return DEMUX_JUMP;
}
